/*
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 2 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 */
#include <stdlib.h>
#include <gtk/gtk.h>
#include "callback.h"
#include "def.h"

/* interface_create: take cares of building the interface.
 * Please keep this function at the end of this file.
 */
GtkWidget ** interface_create(struct _prog *prog_data)
{
	GtkWidget *fenetre;
	GtkWidget *vbox;
	GtkWidget *hbox;
	GtkWidget *button;
	GtkWidget *aire_de_dessin;
	GtkWidget *icon;
	GtkWidget *label_msg;
	GtkWidget *frame_game;
	GtkWidget *frame_pts;
	GtkWidget *table_game;
	GtkWidget *table_pts;
	GtkWidget *label_gamestat_left;
	GtkWidget *label_gameturn_left;
	GtkWidget *label_gametrump_left;
	GtkWidget *label_gamestat_right;
	GtkWidget *label_gameturn_right;
	GtkWidget *label_ptsleft;
	GtkWidget *label_ptsright;
	GtkWidget *vbox_pts;
	
	GtkWidget **widgets = NULL;
	
	widgets = (GtkWidget **) malloc(sizeof(GtkWidget *)* 12);
	
	if(widgets != NULL)
	{
		fenetre = gtk_window_new(GTK_WINDOW_TOPLEVEL);
		gtk_window_set_title( GTK_WINDOW(fenetre), "Belooted" );
		g_signal_connect( G_OBJECT(fenetre), "destroy", G_CALLBACK(quit), prog_data );
		g_signal_connect( G_OBJECT(fenetre), "check_resize", G_CALLBACK(resize), prog_data );

		hbox = gtk_hbox_new(FALSE, 0);
		gtk_container_add( GTK_CONTAINER(fenetre), hbox);
		
		aire_de_dessin = gtk_drawing_area_new();
		gtk_box_pack_start(GTK_BOX(hbox), aire_de_dessin, TRUE, TRUE, 2);
		
		gtk_widget_set_size_request( aire_de_dessin, 450, 420);
		
		vbox = gtk_vbox_new(FALSE, 0);
		
		gtk_box_pack_start(GTK_BOX(hbox), vbox, FALSE, TRUE, 2);
		
		gtk_container_set_border_width(GTK_CONTAINER(vbox), 4);
		
		
		frame_game = gtk_frame_new("Game");
		
		gtk_box_pack_start(GTK_BOX(vbox), frame_game, FALSE, TRUE, 2);
		
		table_game = gtk_table_new(3, 2, FALSE);
		
		gtk_container_add( GTK_CONTAINER(frame_game), table_game);
		
		gtk_container_set_border_width(GTK_CONTAINER(table_game), 10);
		
		gtk_table_set_col_spacings(GTK_TABLE(table_game), 5);
		gtk_table_set_row_spacings(GTK_TABLE(table_game), 5);
		
		
		
		label_gamestat_left = gtk_label_new("Master:");
		label_gametrump_left = gtk_label_new("Trump:");
		label_gameturn_left = gtk_label_new("Turn:");
		
		gtk_misc_set_alignment(GTK_MISC(label_gamestat_left), 1, 0.5);
		gtk_misc_set_alignment(GTK_MISC(label_gameturn_left), 1, 0.5);
		gtk_misc_set_alignment(GTK_MISC(label_gametrump_left), 1, 0.5);
		
		gtk_table_attach_defaults(GTK_TABLE(table_game),
			label_gamestat_left, 
			/*left, right, top, bot*/ 0, 1, 0, 1);
		
		gtk_table_attach_defaults(GTK_TABLE(table_game),
			label_gameturn_left, 
			/*left, right, top, bot*/ 0, 1, 1, 2);
		
		gtk_table_attach_defaults(GTK_TABLE(table_game),
			label_gametrump_left, 
			/*left, right, top, bot*/ 0, 1, 2, 3);
		
		
		icon = gtk_image_new();
		
		gtk_widget_set_size_request(icon, 16, 16);
		
		gtk_misc_set_alignment(GTK_MISC(icon), 0, 0.5);
		
		
		label_gamestat_right = gtk_label_new("N/a");
		label_gameturn_right = gtk_label_new("None");
		
		gtk_misc_set_alignment(GTK_MISC(label_gamestat_right), 0, 0.5);
		gtk_misc_set_alignment(GTK_MISC(label_gameturn_right), 0, 0.5);
		
		gtk_table_attach_defaults(GTK_TABLE(table_game),
			label_gamestat_right, 
			/*left, right, top, bot*/ 1, 2, 0, 1);
		
		gtk_table_attach_defaults(GTK_TABLE(table_game),
			icon, 
			/*left, right, top, bot*/ 1, 2, 2, 3);
		
		gtk_table_attach_defaults(GTK_TABLE(table_game),
			label_gameturn_right, 
			/*left, right, top, bot*/ 1, 2, 1, 2);
		
		
		
		
		
		
		
		frame_pts = gtk_frame_new("Points");
		
		gtk_box_pack_start(GTK_BOX(vbox), frame_pts, TRUE, TRUE, 2);
		
		vbox_pts = gtk_vbox_new(FALSE, 2);
		
		gtk_container_add( GTK_CONTAINER(frame_pts), vbox_pts);
		
		table_pts = gtk_table_new(2, 2, TRUE);
		
		gtk_box_pack_start( GTK_BOX(vbox_pts), table_pts, FALSE, TRUE, 2);
		
		gtk_container_set_border_width(GTK_CONTAINER(table_pts), 10);
		
		gtk_table_set_col_spacings(GTK_TABLE(table_pts), 5);
		gtk_table_set_row_spacings(GTK_TABLE(table_pts), 5);
		
		
		
		gtk_table_attach_defaults(GTK_TABLE(table_pts),
			gtk_label_new("You"), 
			/*left, right, top, bot*/ 0, 1, 1, 2);
		
		gtk_table_attach_defaults(GTK_TABLE(table_pts),
			gtk_label_new("Computer"), 
			/*left, right, top, bot*/ 1, 2, 1, 2);
		
		
		
		
		
		label_ptsleft = gtk_label_new("0");
		label_ptsright = gtk_label_new("0");
		gtk_table_attach_defaults(GTK_TABLE(table_pts),
			label_ptsleft, 
			0, 1, 0, 1);
		
		gtk_table_attach_defaults(GTK_TABLE(table_pts),
			label_ptsright, 
			1, 2, 0, 1);
		
		
		
		gtk_box_pack_start( GTK_BOX(vbox_pts), gtk_label_new(NULL), 
			TRUE, TRUE, 2);
		
		label_msg = gtk_label_new(NULL);
		
		gtk_box_pack_start(GTK_BOX(vbox_pts), label_msg, FALSE, FALSE, 2);
		
		
		
		
		
		
		
		
		
		
		
		/*spinbutton= gtk_spin_button_new(
			GTK_ADJUSTMENT(gtk_adjustment_new(3,1,4,1,1,1)), 0, 1
		);
		spinbutton = gtk_spin_button_new_with_range(1, 4, 1);
		gtk_widget_set_sensitive(spinbutton, FALSE);
		
		gtk_box_pack_start(GTK_BOX(vbox), spinbutton, FALSE, FALSE, 2);
		*/
		
		
		
		
		
		button= gtk_button_new_with_label("Start");
		gtk_widget_set_sensitive(button, FALSE);
		
		gtk_box_pack_start(GTK_BOX(vbox), button, FALSE, TRUE, 2);
		
		
		
		
		
		
		
		
		g_signal_connect( G_OBJECT(button), "clicked", G_CALLBACK(event_start), prog_data);
		
		g_signal_connect( G_OBJECT(aire_de_dessin), "realize", G_CALLBACK(realisation), prog_data );
		g_signal_connect( G_OBJECT(aire_de_dessin), "expose_event", G_CALLBACK(rafraichissement), prog_data );

		gtk_widget_add_events(aire_de_dessin, GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK | GDK_BUTTON_MOTION_MASK );

		g_signal_connect(G_OBJECT(aire_de_dessin), "button_press_event", G_CALLBACK(button_press_event), prog_data);
		g_signal_connect(G_OBJECT(aire_de_dessin), "button_release_event", G_CALLBACK(button_release_event), prog_data);

		g_signal_connect(G_OBJECT(aire_de_dessin), "motion_notify_event", G_CALLBACK(motion_notify_event), prog_data);
		
		
		
		
		
		
		widgets[0] = fenetre;
		widgets[1] = NULL;
		widgets[2] = button;
		widgets[3] = NULL;
		widgets[4] = NULL;
		widgets[5] = icon;
		widgets[6] = label_msg;
		widgets[7] = label_gamestat_right;
		widgets[8] = label_gameturn_right;
		widgets[9] = table_pts;
		
		widgets[10] = label_ptsleft;
		widgets[11] = label_ptsright;
		
		prog_data->area = aire_de_dessin;
	}
	
	return(widgets);	
}
